package com.example.nekontakte.posts.api;

import java.time.LocalDateTime;
import java.util.Date;

import org.springframework.format.annotation.DateTimeFormat;

import com.example.nekontakte.posts.model.PostEntity;
import com.example.nekontakte.users.api.UserDTO;
import com.fasterxml.jackson.annotation.JsonProperty;

import jakarta.validation.constraints.NotNull;

public class PostDTO {

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Integer id;

    @NotNull
    private Integer userId;

    private UserDTO userDTO;

    public UserDTO getUserDTO() {
        return userDTO;
    }

    public void setUserDTO(UserDTO userDTO) {
        this.userDTO = userDTO;
        this.userId = userDTO.getId();
    }

    @NotNull
    @DateTimeFormat(pattern = "dd-MM-yyyy HH:mm")
    private LocalDateTime pubDate;

    private String image;

    private String text;

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public LocalDateTime getPubDate() {
        return pubDate;
    }

    public void setPubDate(LocalDateTime pubDate) {
        this.pubDate = pubDate;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public static PostDTO createFromEntity(PostEntity entity) {
        PostDTO post = new PostDTO();
        post.setId(entity.getId());
        post.setUserId(entity.getUser().getId());
        post.setText(entity.getHtml());
        post.setImage(entity.getImage());
        post.setPubDate(entity.getPubDate());
        post.setUserDTO(UserDTO.createFromEntity(entity.getUser()));
        return post;
    }
}
